/*$Id: d_mos2.h,v 16.14 1999/12/19 22:52:34 al Exp $ -*- C++ -*-
 * MOS model - Spice level 2
 */
#ifndef D_MOS2_H
#define D_MOS2_H
#include "d_mos123.h"
/*--------------------------------------------------------------------------*/
class SDP_MOS2 : public SDP_MOS123 {
public:
  explicit SDP_MOS2(const MOS_COMMON*);
public:
  double   relxj;
  double   eta_1;
  double   eta;	 
  double   eta_2;
};
/*--------------------------------------------------------------------------*/
class MODEL_MOS2 : public MODEL_MOS123 {
  friend class SDP_MOS2;
private:
  explicit	MODEL_MOS2(const MODEL_MOS2& p):MODEL_MOS123(p){unreachable();}
public:
  explicit	MODEL_MOS2();
private: // override virtual
  void		parse_params(CS&);
  void		post_parse();
  SDP_MOS_BASE* new_sdp(const MOS_COMMON* c)const {return new SDP_MOS2(c);}
  void		print(OMSTREAM&,int)const;
  void		tr_eval(COMPONENT*)const;  
private:		/* strictly internal */
  enum {LEVEL=2};
private:		/* input parameters */
  double   nfs;		/* -23--- fast surface state density */
  double   vmax;	/* -23--- max drift velocity of carriers */
  double   neff;	/* -2---- total channel charge coefficient */
  double   ucrit;	/* ----c- critical field mobility degradation */
  double   uexp;	/* -2---- critical field exponent in mob.deg. (mos2) */
  double   utra;	/* ------ transverse field coefficient (not used) */
private:		/* calculated parameters */
  double   xd;		/* -23-c- sqrt(alpha) */
  double   xwb;		/* -2--c- xd * sqrt(pb) */
  double   vbp;		/* -2---- ucrit * E_SI / cox (mos2) */
  double   cfsox;	/* -23--- Q * nfs / cox */
};
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
#endif
